 6.2.9
 
 * fixed a bug in unsquashfs, it didn't work well on SMP machines


 6.2.8
 
 * don't umount filesystems if fatal() function is called, so we can
   actually investigate the real state of things
 * add to fstab only filesystems recognized by kernel (from /proc/filesystems)
   one exception: support ntfs-3g, which is (obviously) not in /proc/filesystems
 * add pri=1 parameter for swap partitions for better swap performance
 * added two new functions, mutex_lock and mutex_unlock (for a named lock)
 * upgraddd userspace utilities (ntfs-3g, fuse, etc)
 * add iocharset fstab option for CDROM filesystems
 * when using posixovl, use 'find' to cache dentries. This seems to be needed
   with 2.6.27+ kernels, as a workaround (a bug in FUSE or posixovl?)


 6.2.7
 
 * loadlin didn't work anymore due to big filesize of vmlinuz and initrd.
   It has been replaced by linLd. See cd-root/boot/dos/
 * fstab_update: add /dev/shm mount to fstab
 * list_all_partitions: list all devices from /dev/mapper/ as well (for LVM)
 * a swap partition will use 'none' as a mountpoint in fstab
 * updated fuse tools (binaries)
 * preallocate 20 more loop devices just for the case
   (this should be perhaps solved somehow better, but is enough for now)
 * cleanum /union/mnt/ directory (delete all empty directories every boot)
 * busybox has been recompiled to provide network tools (ifconfig, udhcpc, ...)
 * if 'ip=' boot parameter is present, initialize network drivers, request
   IP address from DHCP server and mount live data over HTTP from the server
   provided as a second argument to the ip= boot param (separated by semicolon)
   Usually, the ip= parameter is added by pxelinux, and it looks like:
   ip=<client-ip>:<boot-server-ip>:<gw-ip>:<netmask>
 * at the end of linux live scripts, print a message "starting $LIVECDNAME"
   (for example: "starting slax"). Also the message "looking for data directory"
   and few more others are now personalized as well.
   Thanks to Manfred (Quax) for this idea :)
 * dir2lzm: chmod created lzm module to be readable by all


 6.2.6

 * modified activate script to execute scripts only from the following directories (and no subdirectories):
 /etc/rc.d/
 /etc/rc.d/init.d
 Note that /etc/init.d is not supported, because Slackware doesn't use it (it's a symlink to /etc/rc.d/init.d/)
 * activate now logs all executed scripts to /var/log/livedbg
 * added missing debug_log call to find_modules() function
 * new function find_n_run_scripts, which helps in 'activate' and 'deactivate'


 6.2.5

 * retry losetup with -r in case of any error, this may happen if losetup
   supports -r (eg. in util-linux-ng), because in that case it doesn't
   automatically try read-only open()


 6.2.4
 
 * activate and deactivate must work even without k{activate/deactivate} scripts
 * bugfix: sgnfile boot parameter was not working 
 * make_iso.sh now works even if called from a different directory
 * the meaning of nocd parameter is now different: skip looking for CD devices during bootup, but normally
   add cdrom devices to fstab.
 * fixed copy2ram if modules are in subdirectories of /base /modules or /optional
 

 6.2.3
 
 * added newest memtest86+ 2.1
 * recompiled mksquashfs and unsquashfs binaries. Maybe this will fix the problem
   reported by 4 people regarding corruption? I can't reproduce it, everything
   works very well here... this is odd
 * swap in /etc/fstab should now be marked as 'auto' only, no 'noauto'
 * try to find out filesystem of CD devices as well
 * remount current partition 'exec' if 'noexec' is active - for liloinst.sh and bootinst.sh
 * upgraded to newest FUSE 2.7.3 and NTFS-3g
 * make posixovl less sceptic (use kernel cache and set relookup timeouts to 300 seconds)
   in order to get 2x better performace
 * upgraded to busybox 1.9.1, added swaponoff and mkswap applets


 6.2.2

 * fixed the default MKMOD variable, thanks to Mark De Silva


 6.2.1
 
 * bootinst.sh renamed to liloinst.sh
 * added EXCLUDE variable to .config
 * fixed /etc/fstab inclusion in the etc.lzm module ... it must be excluded
 

 6.2.0
 
 * don't use udba=none (defaults now to udba=reval) because of FUSE
   This can have bad impact on performance in some cases, but not in Linux Live.
   Particularly, our writable filesystem is always on a single branch, and other
   branches (squashfs images) are 'rr' (always-readonly) in aufs, so it never
   assumes a direct branch access on them.
 * modprobe filesystem modules explicitly
 * added new fuse filesystems (posixovl, ntfs3g)
 * force keep_cache in posixovl_open() in order to help AUFS
 * don't erase fstab file but only touch it in linuxrc, thanks to Claus Klein!
 * use relative paths in chroot calls, thanks to Patrik Zawadzki
 * added 'pcimodules' script to ./rootfs/bin/, thanks to Patrik Zawadzki for the idea
   (currently unused, but may be interesting for someone)
 * copy few more modules to initrd (cdrom, ide), thanks to Patrik Zawadzki
 * 'uselivemod' renamed to 'activate'
 * 'unuselivemod' renamed to 'deactivate'


 6.1.6
 
 * removed rmlivemod and reimplemented the functionality to unuselivemod
 * removed floppy entry from fstab-create, udev will hopefully create it
 * added back 'noauto' mount parameter for swap devices, as auto swapping
   may be a security problem (if you type a password anywhere, it is in
   memory, and if that part of memory is swapped, the password would be 
   stored on disk ... this is mostly harmless, but most people hate it)
 * added newer versions of busybox, ntfs-3g and fuse to initrd
 * added 'sgn=' boot parameter. Use it to overide file name for livecd.sgn
 * updated mksquashfs and unsquashfs to reflect CVS changes in squashfs
 - this also fixes a bug in mksquashfs to show 100% progress bar correctly


 6.1.5
 
 * re-executing of cleanup script caused the $1 argument to be lost. Fixed.
 * added bootsplash (kind of, a splashy replacement) but not activated by default.
   maybe it will not be actovated at all... It's just a try (and splash is useless anyway, imho)
 * create_module(): never append to existing file, always overwrite (rm -f)
 * find_file(): allow /mnt/sda1/slaxsave.dat for example (/mnt will be replaced by /dev)
 * removed max_loop boot parameter entirely. New kernel doesn't need this anymore
   Tested on 2.6.23-rc2.
 * implemented posixovl overlay. It's started if the branch doesn't support links.
   WARNING! You must use newer version of aufs in order for posixovl to work, because older aufs
   doesn't have some FUSE workarounds and can't simply see the posixovl mount.
 * if 'changes=directory' is used and the directory exists but is not writable (eg is on CD), silently skip changes= at all.
 * added few more mount options for vfat mouts, to make posixovl work better over vfat
 * removed chexpand boot parameter. changes=loop_device.xfs is now deprecated, simply create a directory
   and use changes=/path/to/directory ... if VFAT or NTFS is used to store changes, it will be overlayed
   by posixovl. Still, a Linux filesystem for 'directory' is recommended! though.
 * mountpoint() renamed to ismountpoint() as the 'mountpoint' binary doesn't
   work with loop files, only with directories
 * fumount no longer performs lazy-unmounts automatically, you have to specify -l.
 * It's now able to unmount eg. /dev/sda1 device correctly if /mnt/sda1/filename is given as an argument
 * removed mo2lzm script; people should STOP USING IT! I hate myself for releasing it anyway.
 * modified dir2lzm script, added many checks in order to warn user to make
   his module bit better
 * remove noauto from swap devices, because a hybernated swap can't be used
   by swapon anyway (hybernation modifies swap signature). It's SAFE to swapon.
   Thanks to ElecCham for heads up!
   Note: noauto boot parameter is still mandatory - with it, noauto is used only.
 * add squashfs branches with =rr flag instead of =ro to aufs
 * fstab-update now marks the root filesystem as 'aufs' instead of tmpfs, which is more correct technically,
   but will make some people confused.
 * mount_module now calls mount_device function, in order to bypass the 256 loop
   limitation correctly


 6.1.4
 
 * KDE with HAL does no more need the stupid suffixes for mountpoints 
   (like _removable, _cdrom, etc) so Linux-Live scripts need it no more as well.

 * removed kuselivemod, as it will be part of Slax, not linux live scripts
 * added /dev/zero to initrd
 * updated ntfs-3g driver

 * chopt=eie removed at all
 * replaced by 'chexpand=n' where n is bigger than 16,
   so it does no more fill up the device entirely, but only expands the
   changes-file to the given size in megabytes. The file does no longer need
   to be empty, but still must exist. Smaller file will remail unchanged.

   It is required to use XFS filesystem in the changes file in order to expand
   existing filesystem correctly. If you use different filesystem, you'll have
   to modify liblinuxlive - the function grow_changes().

 * use fumount instead of umount everywhere

 * init binary is copied to memory before chroot, so it's possible to umount
   union during system shutdown (if user doesn't execute 'init U').
   This takes about 500KB of memory, but it's the only way to safely unmount
   all resources, free up loop devices, etc.

 * refined the cleanup script
 * added killall_unneeded function to liblinuxlive, called from cleanup


 6.1.3 - code name Derren Brown

 * updated pci.ids
 * find_file: REMEMBER which devices do not contain the given filename/path
   and don't search for this filename/path anymore on these devices.
   /tmp/_findfile is used for this purpose. This change makes it behave
   The Right Way (tm). Nevertheless, is there a better way than a temp file?
 * timeout boot parameter renamed to scantimeout
 * removed printk modification from mount_device() as it's no longer needed
 * nohotplug bootparam now causes USB and PCMCIA drivers to NOT load
   (has no effect if you compiled these to kernel directly)


 6.1.2 - some more fixes
 
 * fixed a bug in kuselivemod (thanks to Manfred Mueller aka Quax)
 * fixed the 'timeout' boot param, thanks to pingus
 

 6.1.1 - some fixes
 
 * fixed incorrect ntfs-3g binaries
 * fixed some old binaries in rootfs
 * fixed chopt when changes=directory is given


 6.1.0 - code name Test it
 
 * introduced livecd.sgn again, as experiences show it's needed
 * fixed a problem in cmdline_value and cmdline_parameter with -w.
   For some odd reason egrep -o -w 'load' returns a string from 'noload'.
 * fixed a bug in mountpoint call, it was OK if using 'mountpoint' from LLS,
   but wasn't correctly redirecting stdout to null if called busybox's internal
   function. I think it didn't cause any problem at all but now it's called
   the 'right way'(tm).
 * fixed a function rcopy in initrd_create while using $ROOT, suggested by Rick.
 * point aufs xino path to tmpfs memory instead of $CHANGES. This allows us to
   use a fuse-mounted directory for 'changes=' and hides the .fuse_hidden files
   from root caused by xino. Moreover it should be much faster and safer then
   storing it in 'changes' file which may be on USB device. This is now done 
   the 'right way'(tm).
 * obsolete syntax `command` replaced by $(command)
 * removed nodma boot option as I don't see any reason for it anymore
 * usb and pcmcia devices are now probed right away, refined find_in_computer
   function, boot speedup by 20 seconds
 * updated NTFS-3g to the newest version


 6.0.9 - code name NTFS

 * little corrections to addlocale, fixed ROOT variable support
 * direct NTFS-3g support, configurable in .config
 * added [locale= | language= | lang= ]
   example: lang=czech will be recognized as cs_CZ.ISO-8859-2
   If you don't use iocharset= boot option, iocharset for FAT32 partitions
   will be set to the string recognized from locale. In our example iso8859-2.
 * increased the size of initrd (using 6.6 MB instead of old 4.4 MB)
 * added busybox 1.5, compiled with bbconfig, patched to hide msgs about job control turned off
 * removed egrep_o function and replaced by egrep -o (supported by busybox now)
 * added -w to cmdline_parameter and cmdline_value to simplify regular expressions


 6.0.8 - code name: Hasta la VISTA!

 * fixed mountpoint function to correctly recognize mounted directories.
   It worked correctly in BusyBox (during LiveCD startup) because it called
   busybox's mountpoint, but it was broken if called from bash. Not a big 
   prolem but it should be working in both cases
 * added support for booting from PCMCIA CardBus-compatible devices
 * added missing sanity check after mounting partition without read-only flag
 * added a possibility to include locales for given language in initrd
 * fstab-update adds a line for sysfs to fstab, thanks to loonix!
 * swap devices are added with 'noauto' option to fstab, as it is not safe
   to automatically use swap. There can be some other Linux OS hybernated.
 * modprobe_module now accepts many arguments, passing them to modprobe
 * added brs=1 parameter to aufs modprobe, so the module is loaded with 
   full sysfs support
 * mounting is now done using -n option, to skip modifying /etc/mtab
 * if mount -o loop fails, try mknod next loop device in /dev and mount again
   This enables you to use unlimited number of loop devices, if kernel supports it
   (It should be in since 2.6.22, but who knows)
 * mount aufs union with nowarn_perm and udba=none options
 * rewqritten fstab_update, split the functionality into few more functions
 * make_iso.sh now shows real path (readlink -f) instead of the ../../ ...


 6.0.7 - code name: dd seek=`df`
 
 * upgraded to new busybox 1.4.1 with bbconfig applet
 * added mkfs.xfs (compressed by upx) to initrd
 * implemented chopt= boot argument. For now it accepts only:

   'chopt=eie' (stands for: CHanges OPTion = Expand If Empty)
   
   In this case, if the boot argument changes=/path/save.dat is given
   and if the file save.dat is empty (zero size) at the same time, 
   the file will be automatically expanded to the full size of your device.

   For example, if you're running your live distro from a 512 MB USB disk 
   and your distro's data take up 200 MB, then save.dat will be created 312MB

   Finally XFS filesystem is created in the file and it's mounted.
   Minimum free space required is 17MB, as XFS can't be smaller.

 * fixed a typo preventing changes= working if Live distro is started from CD
   but changes are required to load from USB device
 * fixed a typo preventing from= working at all (we should use -d, not -f)


 6.0.6 - code name: Japanese
 
 * fixed make_iso.bat for windows (including broken config from tools/WIN)

 * search for changes= boot argument after the partition with LiveData is mounted.
   Search in the mounted filesystem first, then try other ones. This makes sure
   that, for example, changes=slaxsave.dat searches for slaxsave.dat on the
   boot device first, then it tries other devices and partitions.
 * fixed some problems in booting from USB devices using from=/dev/{USB} param.
 * probe of USB modules is done only once, even if called several times
 * using '-t ext2' parameter to mount initrd image in initrd_create script
 * don't copy unnecessary files to CD
 * file memtest86p renamed to mt86p as it caused some troubles on fat16
   nevertheless the boot parameter is still called 'memtest86p'

 * all NLS kernel modules are now copied to initrd, as I discovered it is useful
 * mounting of dos filesystems (vfat and ntfs) now always use the iocharset given
   by boot parameter iocharset=. This makes it easier to make live distributions
   for foreign users, like Japanese.
                                        ! read DOC/international.txt


 6.0.5

 * fixed cleanup script to skip ejecting of CD when copy2ram is used
 * fixed a bug when swap partitions were not marked 'noauto' even if noauto
   boot parameter was specified
 * modified search routines, all partitions are mounted read-only now
   and only the partition found for liveCD data or changes= or from= is
   remounted without 'ro' flag at the end
 * all partitions are now in all circumstances mounted with 'noatime' option
 * boot prompt now waits 4 seconds before vmlinuz is loaded
 * wait for Enter after liveCD is created (at the end of ./build script)
 * LIVECDNAME (see .config) now affects the name of syslinux/isolinux label.
   That means, if you use 'aaa' as a LIVECDNAME, then you'll need to use
   boot: aaa copy2ram
   for example, instead of 'boot: linux copy2ram' like before
 * linux.bat from boot/dos is now renamed to $LIVECDNAME.bat (only 8 chars)
 * LIVECDNAME can be entered during ./build procedure (there is a prompt for it)
 * ./install is called automatically from ./build now


 6.0.4

 * mo2lzm - first try to mount the .mo module instead of unpacking it.
   only if that fails, unsquashfs to tmp directory
 * linuxrc - support bin/chroot and sbin/chroot (for gentoo)
 * changed default LIVECDNAME to 'livecd', I forgot 'slax' inthere
 * implemented changes to make_iso.bat script


 6.0.3

 * I forgot to include all required directories in the MKMOD variable
   in .config file. Fixed


 6.0.2

 * fixed mo2lzm script, it didn't create lzm file in correct directory
   and it didn't clean up used space
 * fixed uselivemod to detect correctly if .lzm module is inside the union 
   and if it is needed to move it to memory
 * removed unionctl and call everything directly now
 * fixed remounting of union which may caused errors during startup
   when many modules (eg. 50) are used
 * current aufs limitation is 127 modules, never try to use more!
 

 6.0.1

 * minor update of some messages
 * fixed a bug in linuxrc, missing 'then' command, ough!
 * added missing rev command to initrd, ough!
 * modified unionctl to work with busybox
 

 6.0.0
 
 * added bootinst.sh and bootinst.bat scripts to make your disk boot Slax
 * internal: ISOMOUNT variable renamed to LOOPMOUNT
 * new boot parameter waitusb=10 (how long to wait after modprobe usb modules, in seconds)
 * modprobe USB modules requires even longer time then delay_use from /sys.
   Default is 10 seconds now, can be modified by waitusb (see above)
 * modprobe USB modules only if really needed. This means:
   - if debug parameter is present (we need usb keyboard)
   - if changes= parameter exists and find_file didn't find the specified file
   - if LiveCD data can't be found (the error message modified a bit)
 * probeusb boot parameter no longer needed and thus removed
 * log all boot parameters we are asking for to /var/log/livedbg
 * updated uselivemod script, should work now
 * added newest version of unionctl script from aufs cvs
 * added newest syslinux which supports subdirectories and FAT32


 6.0.0-pre6

 * fixed a typo caused by previous fix regarding /usr/sbin/chroot
 * fixed a bug while calling /sbin/mdev as a hotplug handler where it didn't exist
 * added few comments to linuxrc
 * search for bin/init as well as for sbin/init
 * show useful error message if something goes wrong with chroot or init
 * your distro doesn't need to use udev anymore (/dev/ devices are created from /sys)


 6.0.0-pre5
 
 * fixed a bug while calling make_iso.sh (the ISO was not created)
 * fixed a bug where people using /usr/sbin/chroot wasn't able to run
   the LiveCD properly (thanks to ghcooper!) 
 

 6.0.0-pre4

 * fixed a problem when using changes= and from= at the same time and the
   changes.dat file is located at the same partition like 'from='.
   Thanks to Robert Tate!


 6.0.0-pre3
 
 * included stripped list of PCI IDs
 * modprobe only the USB modules which are needed. lspci -v is used 
   to recognize which  module (driver) should be used, eg. uhci, ohci, ehci
 * CD restructuralized, it should now contain only 'boot' and 'slax' directories
 * kernel modules in initrd are no more gzipped
 * many nls kernel modules are no longer included in initrd, only these: cp437,iso8859-1,iso8859-2
 * modprobe - using native busybox function now which handles dependencies much better
   (this also fixes a bug in modprobe_module, some kernel modules were inserted in wrong order)
 * you don't need to patch startup scripts of your distro in order to remove 
   remounting root partition rw (like in old linux-live <6); thanks to aufs!
 

 6.0.0-pre2

 * installing of linux-live scripts now install to /usr/bin instead of /usr/sbin
 * .mo extension renamed to .lzm (stands for Live Zipped Module, or LZMA compressed module)
 * runme.sh renamed to 'build'
 * config file renamed to '.config'
 * added new config option to config file: LIVECDNAME; defaults to 'slax'
   (this allows you to create own liveCD with own branding)
 * create_block_devices replaced by mdev (busybox applet)
 * using newer (better) LZMA patches, thanks to Junjiro Okajima!
 * removed loop devices from initrd creation (/dev/loop*)
 * aufs and squashfs kernel modules are now copied directly from system's
   directory (see LMK config option in .config file),
   no need to copy them to linux live scripts anymore


 6.0.0-pre1
 
 * using squashfs with LZMA patches
 * using aufs instead of unionfs, thanks to Junjiro Okajima!
 * squashfs smp fixes thanks to Junjiro Okajima!
 * added $ROOT to initrd_create, to make sure kernel modules with drivers
   are copied from correct source directory


 5.5.0
 
 * fixed another bug in cleanup script 
   - created ls symlink to eject the right CD
 * added older version of unionctl which works better then the newer one
 * boot by using loadlin now includes vga=769 boot argument
 * boot by using loadlin and syslinux now includes probeusb argument
 * probeusb now waits 5 seconds instead of 3
 * probeusb accepts value (in seconds), eg. probeusb=10 will wait 10 seconds
 * fixed problem with some missing partitions which should be added to fstab


 5.4.9
 
 * bugfix: /etc/fstab is deleted before update_fstab is called from linuxrc,
   this makes sure there are no old lines (from original distro)
 * bugfix: cleanup script now ejects CD properly
 

 5.4.8
 
 * added busybox 1.1.3 with $((arith)) support in ash
 * added noswap boot parameter to disable autoloading of a swap parition
 * fixed egrep_o function which caused fromiso to disallow /dev/... paths
 * fixed comma and semicolon replacement in load= and noload= params
 * fixed bug in list_partition_devices (liblinuxlive)
 * fixed linuxrc searching for data (dirname), thanks to Niels Endres
 * load= and noload= are now case-insensitive, thanks to Niels Endres
 * probeusb moved at the top (even before the first debug prompt)
 * added MKMOD variable to 'config' so user can specify which directories
   will be included in liveCD.
 * added -f option to syslinux in make_disk.bat, which allows user to install
   LiveCD to any disk, even if it's not removable
 * added |sort| to list_modules to preserve correct order even after copy2ram
 * patched unsquashfs to return zero value if everything is OK. Patch sent to Phillip
 * important variables moved from linuxrc to liblinuxlive, all paths are now relative
 * added 'cleanup' script for safe shutdown procedures (you must patch your distro
   in order to call /mnt/live/cleanup at the end of your distro's shutdown scripts)


 5.4.7

 * finding livecd.sgn rewritten, now it doesn't search in subdirectories
 * implemented fromiso cheatcode, use eg. fromiso=/dev/sda1/slax.iso
   or eg. fromiso=/dev/sda1/slaxcd/
 * changes= cheatcode modified to accept device names with path,
   eg. changes=/dev/sda1/changes.ch
 * removed default squashfs.ko and unionfs.ko kernel modules.
   People don't read documentation and are confused that my *.ko modules 
   don't work with their kernels.
 * added 'noauto' boot argument, to disable automounting of disks


 5.4.6

 * modified unsquashfs to force overwrite of existing files
   (added -f option and sent patch to Phillip - unsquashfs author)
 * mo2dir now uses unsquashfs -f, so it works even without squashfs support in kernel!
 * modified mo2dir dir2mo and other scripts to work from ./tools/ directory
   even without installing the scripts and even if ./tools/ is not current directory
 * fixed some typos in error messages
 * fixed load= parameter which were broken by changes made in 5.4.5
 * modules are now found in /base /modules and /optional directories
   and all its subdirectories!
 * load= and noload= now officially work as regexp, you may use * which
   is translated to '.*'. Moreover if you have subdirectories of modules,
   you may load or noload all the trees by a single argument


 5.4.5

 * fixed list_modules function to properly handle noload parameter
 * fixed fstab_update_line to skip commented lines (starting with #)
 * copy both zlib_deflate and zlib_inflate kernel modules to initrd


 5.4.4
 
 * added noload cheatcode, to disable loading specified modules (even those from /base/ and /modules)
 * added ramsize= cheatcode, to specify how much RAM is used to store changes (defaults to ramsize=60%)
 * added make_disk.sh script to create bootable Live disk (eg. for USB devices)


 5.4.3

 * forced ntfs to be mounted with ro option in all circumstances
 * added iocharset boot option, to mount VFAT and NTFS drives
   for example, if you have Central European Windows, use iocharset=iso8859-2
 * fixed listing swap partitions in fstab
 * fixed make_disk.bat and tested by few friends


 5.4.2
 
 * updated blkid libraries
 * updated busybox, this fixes several issues with mount
 * added make_disk.bat script to create bootable disk in Windows
   (eg. to install the LiveCD to USB stick or any FAT32 partition in win)
 * updated to latest unionfs snapshot (fix hardlinks count)
 * updated mksquashfs and unsquashfs binaries in tools directory
 * mo2dir shows correct error message if we try to use it on module inside union
 * added iocharset boot option


 5.4.1

 * uselivemod starts ldconfig only if ld.so.conf is found in the module
 * copy2ram now copies /rootcopy/ dir too.
 * fixed list_modules() function, so only modules from 
   /base /modules and /optional are used during boot
 * The changes= boot argument now stores all modules used with uselivemod
   (only if the module has been moved to changes directory, for example by using
    uselivemod /root/module.mo)
 * mo2dir: added error message when trying to mount module from unioned fs.
 * busybox compiled with mountpoint support
 * If module already exists, don't add it to live filesystem anymore.
   In the past, it was mounted to module.mo.x.x.x but now it just ignores it.
   This allows us to never uselivemod any module with the same name like before.
 

 5.4.0
 
 * fixed some very important bug in unionfs (by Junjiro Okajima, sponsored by SLAX)
   that's the reason for the significant version number increase
 * added deb2mo script, thanks to Peter Chabada
 * changed tmpfs size from 80% to 60%, I agree that it's better and safer
   (if there is a lot of RAM, 60% is big enough, if there is not much RAM
    then 60% is safe, better not enough free space instead of silent hang)
 * modified copy2ram feature to preserve directory structure for modules
 * fixed a typo in linuxrc (properly setup /etc/filesystems)
 * added glibc libraries to initrd, busybox is not statically compiled anymore.
   - now we can include dynamically compiled binaries in initrd, cool!
 * added blkid binary
 * fstab_update rebuilded. We don't need to mount partitions to discover
   filesystem, blkid is good in this. Also minor fixes applied
 * uselivemod tries to find out whether our module is stored inside the union.
   If so, then we can't insert it, it has to be copied to memory first. So is done.
 * uselivemod now installs (unpacks) the module to filesystem if union is not in /


 5.2.0

 * added unionfs.ko CVS 20060210-1338
 * fixed nohd boot option to exclude also swap devices
 * fixed #autoremove label for swap devices detected during boot
 * added new syslinux and isolinux binaries, fixed isolinux.bi_
 * added better mkisofs.exe binary, doesn't work in DOS anymore,
   only in Windows 9x/me/nt/xp. This fixes make_iso.bat.
 * include kernel version number in error message when modprobe_module fails
 * better error message if squashfs and unionfs kernel modules are not found
 * added /etc/filesystems with vfat and ext3 entries, to prevent msdos and ext2
   from mounting prior these ones.
 * probe usb modules if probeusb boot parameter is present
   (useful in combination with "changes=" parameter to store changes to USB)
 * ask for kernel during runme.sh - so always correct kernel is used


 5.1.9

 * added debug=0 to mount union parameters to force zero debug.


 5.1.8
 
 * fix isolinux.cfg to display correct splash
 * updated unionfs.html documentation


 5.1.7
 
 * added support for 2.6.13.2 linux kernel, using test26 config from Slackware
 * added memtest v1.60
 * liblinuxlive: added a special #comment to activate_fstab
 * liblinuxlive: copy only usable files when copy2ram is used


 5.1.6
 
 * modified error message if no CD DATA are found.
 * added support for 2.6.12.5 linux kernel
 * default log file is now created in /tmp/linux-live-debug.log
 * fixed uselivemod script (it didn't start rc.d scripts)
 * updated mksquashfs to version 2.2
 * added ifconfig and dmesg support to busybox


 5.1.4
 
 * uselivemod: requires unionfs to be compiled with -DSETUP_BROKEN_LOSETUP=1
 * uselivemod: show all error messages now (eg. if squashfs is inconsistent
               because of broken download of the module)
 * uselivemod: call ldconfig at the end to update ld cache
 * uselivemod: run ALL scripts from the module, which are located in /etc/rc.d/ BUT symlinks.
               Note: scripts from /var/log/setup/... are not executed anymore
 * uselivemod, img2mo, mo2dir, uselivemod: only root can use it
 * liblinuxlive: added allow_only_root function
 * liblinuxlive: echo mounted module and destination to /tmp/_mounts
 * linuxrc: wait more than 30 seconds for USB devices. and raise the delay.
 * liblinuxlive: union_insert_module now prints module basename dir
 * updated isolinux.bin to newest version available today
 * initrd_create: use new config options to disable compressing kernel modules
                  and to redirect debug output to some file or /dev/null
 * added some documentation to "!info" directory
 * added latest CVS snapshot of unionfs module compiled for 2.6.12.2 kernel
   (this one is the more stable unionfs ever)


 5.1.3
 
 * bugfix: precompiled kernel modules weren't gzipped


 5.1.2
 
 * added squashfs kernel modules for 2.6.12.2
 * added unionfs unionfs-063005-2217
 * released 2.6.12.2 precompiled kernel for lazy people
 * added mkisofs which works in MS DOS too!


 5.1.1

 * mo2dir now calls /sbin/ldconfig at the end 
 * added modprobe loop to initrd_create
 * uninstall script
 * removed editiso script. Use make_iso instead...
 * fixed make_iso.bat and added mkisofs.exe for DOS!
 * added uniondbg binary
 

 5.1.0
 5.0.16

 * mnt entries are marked as _cdrom and _removable
 * uselivemod updated to workaround unionfs bug, wasn't able to mount -o loop
 * updated kernel modules for 2.6.11.8, updated unionctl and mksquashfs
 * cd directory tree is changed to be more simple
 * create_bootdisk renamed to make_iso.sh and make_iso.bat
 

 5.0.15

 * added unionfs from 27th of April 2005
 * fixed uselivemod bug
 * new unionfs allows us to mount .mo modules from unioned dir too!
 * added precompiled modules (squashfs, unionfs) for Linux 2.6.11.8


 5.0.14

 * I don't like 5.0.13
 * Autoeject is set to 0 in /proc/.... at the end of copy2ram feature
 * added changes=/dev/device boot parameter. This device will be mounted
   to /memory/changes instead of tmpfs so changes can be stored on the disk!
   (or, for example, on removable USB media)
 * fixed USB mass storage driver? Remove ub driver from kernel, it's slow! :(
 * removed scsi modules from initrd
 * added mkisofs.exe and written create_bootiso.cmd script for Windows!
 * rootcopy content is now copied with cp -a instead of cp -R


 5.0.12
 
 * added NLS (native language support) kernel modules to initrd, allowing 
   us to autodetect and automount FAT filesystems too
 * usb modules are probed too, so USB storage devices are added to fstab
 * added /sbin/modprobe script to initrd so Kernel can modprobe automatically
   (I found it's useless because actually kernel doesn't use it. But I will leave it there) 


 5.0.11

 * added rootcopy directory to Live CD, it's content is copied directly to /
 * added missing vfat support
 * copy2ram copies the whole CD to RAM now
 * added new isolinux.bin


 5.0.10
 
 * added unionfs version which has many important bugs fixed
 * patched unionctl to skip stat() function
 * added support for Linux 2.6.11.6
 * added sample kernel configuration to kernel-modules/*/config.gz
 * added a lot of text to requirements file
 * fixed uselivemod script


 5.0.9

 * added precompiled version of mksquashfs to ./tools
 * added new unionfs (CVS snapshot unionfs-022205-1641)
 * liblinuxlive: added error message to modprobe_module function,
     so errors are displayed in the case if insmod didn't work.
     Some modprobe fixes added
 * busybox: added some more plugins (commands)
 * busybox: patched to support more than 8 loop devices
 * each directory of root filesystem is now packed separately


 5.0.8

 * fix chroot again
 * added Linux 2.6.10 support (precompiled modules)
 * removed Linux 2.6.9 modules
 * all kernel modules in initrd are compressed by gzip


 5.0.7

 * linuxrc: umount /sys before chroot, because Slackware won't moot /sys
   if it's mounted somewhere and it's a good idea to umount it anyway.
 * linuxrc: chroot is called from /usr/bin/chroot at first, if there is 
   no such executable then linux-live scripts try /usr/sbin/chroot


 5.0.6

 * added img2mo tool to convert old format module to new one
 * initrd size changed to 4444KB

 
 5.0.5
 
 * updated unionfs.ko kernel module and unionctl binary


 5.0.4

 * added toram boot parameter (copy2ram is an alias for toram and can be used too)
 

 5.0.3
 
 * small bugfixes in shell scripts


 5.0.2
 
 * linuxrc and liblinuxlive rewritten from the scratch
 * busybox recompiled, it contains vi editor now.
 * added nohd boot option to disable mounting harddiscs at all

 * moduse renamed to uselivemod and rewritten
 * dir2img renamed to dir2mo and rewritten
 * img2dir renamed to mo2dir and rewritten
 * tgz2img renamed to tgz2mo and rewritten

 * when no live data found, try to modprobe USB storage modules
 * when no live data found, modprobe ALL scsi modules, I hope it won't hang

 * not implemented yet: tohd and fromhd boot options
 * not implemented yet: toram (and copy2ram) boot option
 

 5.0.0
 
 * added Linux 2.6 support !!!!
 * added unionfs support
 * added squashfs support
 * added BusyBox binary, which reduces the size of initrd and makes
   linux-live scripts more flexible; removed bash, added ash
 * modinsert renamed to editiso and rewritten
 * added nodma boot option, to disable DMA support upon request for all cdroms and disks
 * create_bootdisk.sh fixed incorrect error message about LILO not installed
 * removed nolock boot parameter
 not yet:* fixed tohd boot option (--test?)
 

 4.2.4
 
 * added installimg script to /tools/
 * added toram boot option, a synonym for copy2ram
 * /home directory is compressed like /root now...
 * fixed list_libs() function in liblinuxlive which could return uncomplete
   list of library dependencies (important bug!)


 4.2.3

 * mount_img() function - use return instead of exit


 4.2.2
 
 * added isolinux 2.11 to bootfiles


 4.2.1

 * mount_img() function produces more usefull error messages now
 * initrd_create: don't fail while copying nonexistent kernel modules (except ovl)


 4.2

 * modified dir2img to properly handle third parameter.
   It defaults to /data for tree without /data
   and it defaults to / for tree with /data
 * initrd size changed to 9999 KB
 * fixed echolog calling from /mnt/tmp/init
 * don't copy ext3, ntfs or reiserfs kernel modules to initrd if they doesn't exist
   (this caused fatal errors during initrd_create)


 4.1.4

 * added some more requirements to be accurate
 * don't export variables to profile.d if it doesn't exist
 * added 2.6 kernels todo
 * added isolinux 2.10
 * modified create_bootiso.sh to allow creating ISO from ro CD
 * added devfsd package to /packages directory


 4.1.3

 * this version number was skipped, I don't like it, it seems unstable


 4.1.2

 * fixed create_bootdisk.sh (adding | head -n 1)
 * added mv command to initrd
 * added cut command to initrd
 * implemented tohd and fromhd boot options


 4.1.1

 * added documentation DOC_MODULES


 4.0.7
 
 * fixed moduse script, added calling of "manual" module script if exists
 * liblinuxlive: added -n to mount calls
 * third argument for dir2img is optional now, it defaults to "/"


 4.0.5
 
 * tar.gz packs are extracted before inserting modules, to allow modules
   to contain /etc and /root settings too.
 * fixed "eject" boot parameter:
   /boot is mounted only if eject is not specified
 * create_bootdisk.sh: fixed lilo (forced to trash old boot record)
 * added memtest v 1.11 (it's finaly working now)
 * fixed ide-scsi - added the missing kernel module


 4.0.4

 * modified F1 boot help text
 * removed lang= functionality
 * removed lang directory from the CD and replaced it by "optional" directory
 * added "load=" boot parameter to insert specified images from "optional" directory
   (for example load=wine,vmware.img,lang_cs will insert optional/wine* optional/vmware.img* and optional/lang_cs*)
 * ./tools/moduse script sets $MANUAL variable to non-null value. This way it's possible
   to know (inside preinsert and postinsert script) if it's inserted manually by
   modinsert ($MANUAL!=""), or automatically during the LiveCD startup (before
   chrooting /mnt as a root filesystem).
 * devfs for /mnt/dev (real /dev) is mounted very soon to allow modules to
   contain device files
 * added memtest boot parameter starting memtest 3.1
 * liveCD path is mounted by --rbind option to /boot
 * mkciso removes the RAW img file imediately after compressing it
   to free some important part of disk space
 * added livecd-check to ./moduse script to disable using modules from hd-installed livecd


 4.0.3

  * linuxrc creates /etc/profile.d/slax.(csh,sh) to export $LIVECD_SUBDIR and $LIVECD_MOUNT
    environment variables
  * added Smart Boot Manager floppy image to FLOPPY/ directory (in bootfiles/)
  * initrd doesn't include SCSI kernel modules any more, seems like it didn't work


 4.0.2
 
  * scripts from /tools look for liblinuxlive functions in two directories now, ./ and /usr/lib


 4.0.1
 
  * fixed copying symlinks to initrd (copy link's target too w/ absolute pathname)
  * created own tempfile function
  * updated error message for mkzftree
  * removed nocopy2ram boot parameter. copy2ram parameter now implifies copy2ram=all
    so it's not possible (it didn't make any sense) to copy/not-copy individual modules
  * All SCSI modules are copied to initrd. This shoudl allow SLAX to boot
    from a cdrom drive connected to SCSI interface! I don't know if the kernel
    can insert apropriate module automatically (without hotplug for example)
    but I believe that it should. If there is someone who could test it,
    let me know please.


 3.0.28

  * Floppy automounting disabled (it caused alot of problems on some hw)
  * Floppy is automounted only with "floppy" boot parameter
  * USB modules for linuxrc are loaded only with "usbdisk" boot parameter
  * Fixed -a (AND) in linuxrc (there was && instead of -a which caused to
    fail loading USB modules at all)
  * Added script to copy&install SLAX to USB Mastorage device (flashdisk)!
    (./bootfiles/create_bootflashdisk.sh, untested but should work)

 3.0.27

  * USB support added back, it's possible to start slax from USB mastorage device
    (only if you know how to boot from it, or by using floppy)
  * added nousb kernel boot parameter again
  * added tools/modinsert.sh script (to insert downloaded modules to LiveCD ISO)


 3.0.26

   mkciso: mkzftree seems unable to compress files >2GB, added a check
   runme.sh: added a check for directories existence (eg. /opt doesn't need to be there)
   accidentaly removed ide-scsi modloading, cd burning doesn't work
   

 3.0.25
 
   fixed mouse autoconfig, it should finaly work now!
   filesystem modules for ext3 and reiserfs added to initrd
   partitions are mounted "ro" in linuxrc, but "default" entry is writed to fstab
   added "lang=" kernel parameter to insert all modules from language cpecific directory cd/lang/$1/*
   fixed loadlin (dos) parameters
   added floppy automounting
   removed usb kernel modules from initrd
   isolinux timeout changed to 2 seconds


 3.0.24

   fixed nohotplug kernel parameter to disable usb modules probing
   fixed img modules with filenames with a dot at the begining in some name
   added passwd=ask kernel parameter to change root password during the boot
   added eject kernel parameter to eject the CD if possible (when copy2ram=all)
   added nolock kernel parameter to disable CD locking
   added devfs and ovlfs checking, print useful error messages if error
   added touch /{etc,root,tmp,var/run}/something to avoid overmounting by ovlfs
   /var is packed by tar+gz like root or etc.
   mouse autodetecting (create /dev/mouse)
   changed module format. It's ISO->COMPRESS->ISO2 now, needs 2 loops to mount
   the final ISO is _not_ compressed. Allows to copy files from CD to RAM / FAT
   debug parameter without =bash will cat /proc/mounts and /proc/self/environ


 3.0.23

   the whole phylosophy completely changed, the LiveCD is modularized now
   cramfs replaced by transparent iso decompression
   autoexec script removed
   added tgz2img.sh script to convert .tgz files into .img
   added dir2img.sh script to convert directory tree into .img
   added img2dir.sh script to convert all back


 2.9.0.22

   changelog for all older versions is lost
